# -*- coding: utf-8 -*-
from openerp import models, fields, tools, api
import openerp.addons.decimal_precision as dp

class ResBankPaymentsLine(models.Model):
    _name = 'res.bank.payments.line'

    amount = fields.Float('amount', digits_compute=dp.get_precision('Account'), required=True, help="Monto del pago")
    amount_currency = fields.Float('amount currency', digits_compute=dp.get_precision('Account'), required=True, help="importe moneda")
    currency_id = fields.Many2one('res.currency', string="Currency", help="Moneda de la operación")
    date = fields.Date()
    bank_payments_id = fields.Many2one('res.bank.payments', string='Bank Payments', ondelete='restrict', index=True, required=True)
    statement_line_id = fields.Many2one('account.bank.statement.line', string='Cash Transactions', ondelete='cascade', index=True)
    statement_id = fields.Many2one('account.bank.statement', string='statement', ondelete='cascade', index=True)
    name= fields.Char(compute='compute_name_line')
    type_operation = fields.Selection([('receipt', 'Recibo'), ('payment','Pago'), ('balance','Balance'), ('cashed', 'Cobrado'), ('renegotiated','Renegociado')], 'Tipo de operación',
                                        help='Tipo de operación  Recibo(Pagos de Clientes)  Pago(Pagos de compras, gastos, hhrr)')

    def compute_name_line(self):
        self.name = "Payments/Line/ "+str(self.id)


class res_bank_payments(models.Model):
    _inherit = 'res.bank.payments'

    payments_line = fields.One2many('res.bank.payments.line', 'bank_payments_id', string='Payments Lines', help="Lineas de pagos")
