# -*- coding: utf-8 -*-
from openerp import models, fields, tools, api

class resBankChequeType(models.Model):
    _name = 'res.bank.cheque.type'

    name = fields.Char('Name', help="Descripción tipo de cheque", required=True)
    code = fields.Char('code', size=64, required=True)
    is_cash = fields.Boolean()
    is_bank = fields.Boolean()

    @api.model
    def _create_cheque_type(self):
        typeCheck = [
            {'name': 'Cruzado', 'code': 'CRUZADO', 'is_cash': False, 'is_bank': True},
            {'name': 'Vista', 'code': 'VISTA', 'is_cash': True, 'is_bank': True},
            {'name': 'Diferido', 'code': 'DIFERIDO', 'is_cash': True, 'is_bank': True}
        ]
        for check in typeCheck:
            checksType = self.env['res.bank.cheque.type'].search([('name', '=', check['name'])])
            types = {'name': check['name'], 'code': check['code'], 'is_cash': check['is_cash'],'is_bank': check['is_bank']}

            if (not checksType):
                checksType.create(types)


class res_bank_payments(models.Model):
    _inherit = 'res.bank.payments'

    cheque_type_id = fields.Many2one('res.bank.cheque.type', string='Tipo de cheque', ondelete='restrict', index=True, help='Tipo de cheque')
