(function() {

    openerp.widgetInstanceCharge = null;
    openerp.parentInstanceCharge = {};
    var QWeb = openerp.web.qweb;
    var instanceWeb = openerp.web;
    openerp.BankPaymentsCharge = openerp.Widget.extend({
        template: 'bank_payments.Charge',
        id: undefined,
        buttons: undefined,
        bankPayments: [],
        accountJournal: [],
        typeOperation: 'cashed',
        refPayments: 'Balance/cobro/',

        /* init */
        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        /* start */
        start: function () {
            var self = this;
            this.$el.find('.bank-payments-charge').click(function(){
                self.fetchInitial();
            });
            self.buttons.click(function(e) {
                /* C (Crear) */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
            });
        },
        /* Check state*/
        checkState: function(id, state) {
            var self = this;
            self.id = id;
            this.$el.find('.bank-payments-charge').css('display','flex');
            if (state !== 'available'){
                this.$el.find('.bank-payments-charge').css('display','none');
            }
        },
        /* reloadPage */
        reloadPage: function() {
             openerp.parentInstanceCharge.reload();
        },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Método inicial  */
        fetchInitial: function() {
            var self = this;
            self.fetchBankPayments(self.id).then(function(bankPayments) {
                return bankPayments;
            }).then(function(bankPayments) {
                self.bankPayments = bankPayments;
                return self.fetchBankPaymentsJournal();
            }).then(function(accountJournal){
                self.accountJournal = accountJournal;
                return self.showModalReturned();
        });
        },
        fetchBankPaymentsJournal: function(id) {
            var bankStatement = new instanceWeb.Model('res.bank.payments');
            return bankStatement.call('get_bank_payments_account_journal',{
                context: new instanceWeb.CompoundContext()
            });
        },
        /* bank payments */
        fetchBankPayments: function(id) {
            var bankPayments = new instanceWeb.Model('res.bank.payments');
            return bankPayments.call('get_bank_payments_charge',[id],{
                context: new instanceWeb.CompoundContext()
            });
        },
        // /* Generar Cobro */
        balanceBankPaymentsCustomers: function(bankCharge) {
            var bankPayments = new instanceWeb.Model('res.bank.payments');
            return bankPayments.call('balance_bank_payments_charge',[bankCharge], {
                    context: new openerp.web.CompoundContext()
            });
        },
        /* Get Ammoutn CUrrency */
        getAmountCurrency: function(currencyId) {
            var self = this;
            var bankPayments =  self.bankPayments[0];
            return _.filter(bankPayments.currencyAmount, function(item) {
                return item.id === currencyId;
            });
        },
        /* get Journal select */
        getJournalSelected: function(id){
            var self = this
            return _.filter(self.accountJournal, function(item) {
                return item.id === id;
            });
        },
        /* get statement journal */
        getStatementeJournal: function(statement,id) {
            return _.filter(statement, function(item) {
                return  item.id === id;
            });
        },
        /* Modal */
        showModalReturned: function() {
            var self = this;
            var defer =$.Deferred();
            var results = true;
            var bankPayments =  self.bankPayments[0];
            var journal = self.accountJournal;

            if (!!journal){
                journal.unshift({
                    'id':'',
                    'name':''
                });
            }

            var amountCUrrency = self.getAmountCurrency(bankPayments.currencyId).shift();
            if (!amountCUrrency)
                return false;

            var modal = QWeb.render('bank_payments.ModalCharge' ,{
                journal: journal,
            });

            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();

            /* Cerrar */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });

            /* Total Ammount  */
            var amountTotal = $('.expired-account-modal').find('.amount-total');
            var symbolAmountTotal = $('.expired-account-modal').find('.symbol-amount-total');
            var selectJournal = $('.expired-account-modal').find('.select-journal');
            var selectStatement = $('.expired-account-modal').find('.select-statement');
            var detailsChargeInput = $('.expired-account-modal').find('.details-charge-input');
            /* Aceptar */
            var buttonSave = $('.expired-account-modal').find('.button-save');

            /* */
            amountTotal.val(accounting.formatNumber(amountCUrrency.amountCurrency,amountCUrrency.decimalPlaces,amountCUrrency.thousandsSeparator,amountCUrrency.decimalSeparator))
            symbolAmountTotal.text(amountCUrrency.symbol);

            /* change Journal */
            selectJournal.change(function(e) {
                journalSelect = self.getJournalSelected(parseInt(selectJournal.val())).shift();
                amountCUrrency = self.getAmountCurrency(bankPayments.currencyId).shift();

                $('.expired-account-modal').find('.is-open-cashbox').css('display', 'none');
                selectStatement.empty();

                if (journalSelect){
                    amountCUrrency = self.getAmountCurrency(journalSelect.currencyID).shift();
                    if (journalSelect.statementJournal.length) {
                        $('.expired-account-modal').find('.is-open-cashbox').css('display', 'flex');
                        var cashboxOpen = '<option value=""></option>';
                        _.each(journalSelect.statementJournal, function(item) {
                            cashboxOpen += '<option value="'+item.id+'">'+item.statementName+'</option>';
                        });
                        selectStatement.append(cashboxOpen);
                    }
                }
                amountTotal.val(accounting.formatNumber(amountCUrrency.amountCurrency,amountCUrrency.decimalPlaces,amountCUrrency.thousandsSeparator,amountCUrrency.decimalSeparator))
                symbolAmountTotal.text(amountCUrrency.symbol);
            });

            buttonSave.click(function(e){
                // amountTotal

                journal = self.getJournalSelected(parseInt(selectJournal.val())).shift();
                if (!journal) {
                    instanceWeb.notification.do_warn("Atencion", "Tienes que seleccionar un método de pago para continuar.");
                    selectJournal.css('border-color','red');
                    selectJournal.focus();
                    return false;
                }
                selectJournal.css('border-color','#ccc');
                var statement = self.getStatementeJournal(journal.statementJournal, parseInt(selectStatement.val()));

                if (!!journal.statementJournal.length && !statement.length) {
                    instanceWeb.notification.do_warn("Atencion", "Tienes que seleccionar una caja para continuar.");
                    selectStatement.css('border-color','red');
                    selectStatement.focus();
                    return;
                }
                selectStatement.css('border-color','#ccc');


                if (!detailsChargeInput.val().trim()) {
                    instanceWeb.notification.do_warn("Atencion", "Debes seleccionar un método de pago para continuar.");
                    detailsChargeInput.css('border-color','red');
                    detailsChargeInput.focus();
                    return;
                }
                detailsChargeInput.css('border-color','#ccc');

                var chequeType = bankPayments.chequeType;
                if (chequeType.length) {
                    if (!chequeType[0].isCash && journal.type ==="cash") {
                        instanceWeb.notification.do_warn("Atencion", "El tipo de cheque no permite operación de tipo efectivo.");
                        selectJournal.css('border-color','red');
                        selectJournal.focus();
                        return false;
                    }
                    if (!chequeType[0].isBank && journal.type ==="bank") {
                        instanceWeb.notification.do_warn("Atencion", "El tipo de cheque no permite operación de tipo banco.");
                        selectJournal.css('border-color','red');
                        selectJournal.focus();
                        return false;
                    }
                    selectJournal.css('border-color','#ccc');
                }

                bankCharge = {
                    'id' :self.id,
                    'selectJournal': journal.id,
                    'statementId': !!statement.length ?statement[0].id :'',
                    'details': detailsChargeInput.val().trim(),
                }

                self.balanceBankPaymentsCustomers(bankCharge).then(function(resultsBanalnce) {
                    return resultsBanalnce;
                }).then(function(resultsBanalnce) {
                    self.reloadPage()
                    if (!resultsBanalnce)
                        results = false;
                });

                defer.resolve(results);
               self.removeModal(e);
            })

            return defer;
        },

    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'res.bank.payments')
                    return;

                openerp.parentInstanceCharge = this;

                if (openerp.widgetInstanceCharge) {
                    openerp.widgetInstanceCharge.checkState(record.id, record.state);
                    if (this.$el.find('.paymnet-charge').length !== 0)
                        return;
                }

                if (this.$el.find('.paymnet-charge').length !== 0)
                    return;

                openerp.widgetInstanceCharge = new openerp.BankPaymentsCharge(this);

                var element =this.$el.find('.oe_form').find('.bank-paymnets-bank');

                openerp.widgetInstanceCharge.appendTo(element[0]);
                openerp.widgetInstanceCharge.checkState(record.id, record.state);
            }
        });
    }
})();
