(function() {

    openerp.widgetInstanceReject = null;
    openerp.parentInstanceReject = {};
    var QWeb = openerp.web.qweb;

    openerp.BankPaymentsReject = openerp.Widget.extend({
        template: 'bank_payments.Reject',
        id: undefined,
        buttons: undefined,
        bankPayments: [],
        bankPaymentsLine: [],
        bankPaymentsType: [],
        accountJournal: [],
        currencySelect: [],
        resCompany: [],
        resCurrency: [],
        /* init */
        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        /* start */
        start: function () {
            var self = this;
            this.$el.find('.bank-payments-reject').click(function() {
                self.fetchInitial();
            });
            self.buttons.click(function(e) {
                /* C (Crear) */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
            });
        },
        /* Check state*/
        checkState: function(id, state) {
            var self = this;
            self.id = id;
            this.$el.find('.bank-payments-reject').css('display','flex');
            if ((state !== 'available') && (state !== 'negotiated')) {
                this.$el.find('.bank-payments-reject').css('display','none');
            }
        },
        /* reloadPage */
        reloadPage: function() {
             openerp.parentInstanceReject.reload();
        },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Método inicial  */
        fetchInitial: function() {
            var self = this;
            self.fetchBankPayments(self.id).then(function(bankPayments) {
                return bankPayments;
            }).then(function(bankPayments) {
                self.bankPayments = bankPayments;
                return self.fetchBankPaymentsLine(self.id);
            }).then(function(bankPaymentsLine){
                self.bankPaymentsLine = bankPaymentsLine;
                return self.fetchACcountJournal();
            }).then(function(accountJournal){
                self.accountJournal = accountJournal;
                return self.fetchResCompany();
            }).then(function(resCompany){
                self.resCompany = resCompany;
                return self.fetchResCurrency();
            }).then(function(resCurrency){
                self.resCurrency = resCurrency;
                return self.fetchBankPaYmentsType(self.bankPayments[0].bank_payments_type_id[0]);
            }).then(function(bankPaymentsType) {
                self.bankPaymentsType = bankPaymentsType;
                if (!!self.bankPaymentsType.length && self.bankPaymentsType[0].code !== 'CH') {
                    openerp.web.notification.do_warn("Atencion", "Solo se puede rechazar cheques" );
                    return false;
                }
                    return self.showModalReject();
            })
        },
        /* bank payments */
        fetchBankPayments: function(id) {
            var bankPaymnets = new openerp.web.Model('res.bank.payments');
            var fields = ['id', 'state', 'payments_line', 'amount_receipt', 'amount_payment', 'amount_total','currency_id','bank_payments_type_id', 'change_payment_method'];
            var domain = [['id', '=', id]];
            return bankPaymnets.query(fields).filter(domain).all();
        },
        /* Bank Paymnets line */
        fetchBankPaymentsLine: function(bankPaymnetId) {
            var paymentLine = new openerp.web.Model('res.bank.payments.line');
            var fields = ['id', 'amount','type_operation', 'bank_payments_id'];
            var domain = [['bank_payments_id', '=', bankPaymnetId],['type_operation', '=', 'payment']];
            return paymentLine.query(fields).filter(domain).all();
        },
        /* bnak Payments Type*/
        fetchBankPaYmentsType: function(typeId){
            var self = this;
            var fields = ['id', 'name', 'code'];
            var domain = [['id', '=', typeId]];
            var bankPaymentsType = new openerp.web.Model('res.bank.payments.type');
            return bankPaymentsType.query(fields).filter(domain).all();
        },
        /*Account Journal  */
        fetchACcountJournal: function() {
            var fields = ['id', 'name', 'code', 'type', 'currency', 'default_debit_account_id', 'default_credit_account_id'];
            var domain = [['active', '=', true], ['type', 'in', ['bank', 'cash']]];
            var journalSalario = new openerp.web.Model('account.journal');
            return journalSalario.query(fields).filter(domain).all();
        },
        /* Consultar Compania */
        fetchResCompany: function() {
            var fields = ['id','name', 'currency_id'];
            var domain = [['id', '=', 1]];
            var resCompanyIds = new openerp.web.Model('res.company');
            return resCompanyIds.query(fields).filter(domain).all();
        },
        /* Consultar Moneda Activas */
        fetchResCurrency : function() {
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position', 'rate'];
            var domain = [['active','=', true]];
            var resCurrecy = new openerp.web.Model('res.currency');
            return resCurrecy.query(fields).filter(domain).all();
        },
        /* Select Journal Change */
        getSelectedJournal: function(code){
            var self = this;
            var journal = self.getJournal(code).shift();
            var company = self.resCompany;

            if (!journal)
                return [];

            if (!journal.currency) {
                self.currencySelect = self.getCurrency(company[0].currency_id[0]);
            }else {
                self.currencySelect = self.getCurrency(journal.currency[0]);
            }
            return !!self.currencySelect ? self.currencySelect : [];
        },
        /* Get Currency*/
        getCurrency: function(id) {
            var self = this;
            return _.filter(self.resCurrency, function(item) {
                return item.id === id;
            });
        },
        /* Get Journal*/
        getJournal: function(code) {
            var self = this;
            return _.filter(self.accountJournal, function(item) {
                return item.code === code;
            });
        },

        // /* Recalcule Receipt*/
        recalculatePaymnets: function(currencySelect) {
            var self = this;
            var changeCurrency = [];
            var  paymnetTotal = 0;
            var paymentsTotalCurrency = 0
            var currencyPayments = self.getCurrency(self.bankPayments[0].currency_id[0]).shift();
            if (!currencySelect || !self.bankPaymentsLine.length)
                return;

            _.each(self.bankPaymentsLine, function(item){
                if (item.type_operation === 'payment')
                    paymnetTotal += item.amount;

            });

            paymentsTotalCurrency = (paymnetTotal * (currencySelect.rate / currencyPayments.rate));

            changeCurrency.push({
                'amountPayments': paymentsTotalCurrency,
                'amountPaymentsFormat': accounting.formatNumber(paymentsTotalCurrency, currencySelect.decimal_places, currencySelect.thousands_separator, currencySelect.decimal_separator),
                'currencySymbol': currencySelect.symbol,
                'rate': currencySelect.rate
            });

            self.bankPaymentsTotal = changeCurrency;
            return !!changeCurrency ?changeCurrency : [];
        },
        /* Modal */
        showModalReject: function() {
            var self = this;
            var defer =$.Deferred();
            var results = true;
            var rejectPayments = [];
            var currencyJournal = [];
            var amountPaymnets = [];
            var modal = QWeb.render('bank_payments.ModalRejectWidget',{
                journal: self.accountJournal
            });
            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();
            /* Cerrar */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });
            /* Details */
            var waitPayments = $('.expired-account-modal').find('.wait-payments');
            var otherPayments = $('.expired-account-modal').find('.other-payments');
            var amountPayments = $('.expired-account-modal').find('.amount-payments');
            var symbolAmountPayments = $('.expired-account-modal').find('.symbol-amount-payments');
            var selectJournal = $('.expired-account-modal').find('.select-journal');
            var detailsReject = $('.expired-account-modal').find('.details-reject-input');

            /* Aceptar */
            var addReceipt = $('.expired-account-modal').find('.add-reject-total');
            var waitPaymentsChecked = null;
            var otherPaymentsChecked = null;

            if (self.bankPayments[0].change_payment_method || !self.bankPaymentsLine.length ){
                $('.expired-account-modal').find('.is-payments').css('display','none');
                $('.expired-account-modal').find('.wait-payments-select').css('display','flex');
                waitPaymentsChecked= []
                waitPaymentsChecked.checked = true;
            }
            /* Recalcular el vuelto según el diario seleccionado */
            currencyJournal = self.getSelectedJournal(selectJournal.val()).shift();
            amountPaymnets = self.recalculatePaymnets(currencyJournal);
            if (!!amountPaymnets && !!amountPaymnets.length) {
                amountPayments.val(amountPaymnets[0].amountPaymentsFormat);
                symbolAmountPayments.text(amountPaymnets[0].currencySymbol)
            }
            /* change Journal */
            selectJournal.change(function(e) {
                /* Recalcular el vuelto según el diario seleccionado */
                currencyJournal = self.getSelectedJournal(selectJournal.val()).shift();
                amountPaymnets = self.recalculatePaymnets(currencyJournal);
                if (!!amountPaymnets.length) {
                    amountPayments.val(amountPaymnets[0].amountPaymentsFormat);
                    symbolAmountPayments.text(amountPaymnets[0].currencySymbol)
                }
            });
            /* esperar pagos */
            waitPayments.click(function(e){
                waitPaymentsChecked = e.target;
                $('.expired-account-modal').find('.other-payments-select').css('display','none');
                if (this.checked) {
                    if (otherPaymentsChecked)
                        otherPaymentsChecked.checked = false;

                    $('.expired-account-modal').find('.wait-payments-select').css('display','flex');
                } else {
                    $('.expired-account-modal').find('.wait-payments-select').css('display','none');

                }
            });
            /* Otro metodo de pagos */
            otherPayments.click(function(e){
                otherPaymentsChecked = e.target;
                $('.expired-account-modal').find('.wait-payments-select').css('display','none');
                if (this.checked){
                    if (waitPaymentsChecked)
                        waitPaymentsChecked.checked = false;

                    $('.expired-account-modal').find('.other-payments-select').css('display','flex');
                    $('.expired-account-modal').find('.wait-payments-select').css('display','flex');
                } else {
                    $('.expired-account-modal').find('.other-payments-select').css('display','none');
                    $('.expired-account-modal').find('.wait-payments-select').css('display','none');
                }
            });

            // amountPayments
            /*Monto */
            amountPayments.keyup(function(e) {
                currencyJournal = self.getSelectedJournal(selectJournal.val()).shift();
                var amount_add = (accounting.unformat(amountPayments.val(),currencyJournal.decimal_separator));
                amountPayments.val(accounting.formatNumber(amount_add, 0, currencyJournal.thousands_separator, currencyJournal.decimal_separator));
                amountPayments.css('border-color','#ccc');

                if (e.keyCode === 13)
                    addReceipt.focus();
            });
            /* Monto */
            amountPayments.focusout(function(e) {
                currencyJournal = self.getSelectedJournal(selectJournal.val()).shift();
                var amountTotal =  (self.bankPayments[0].amount_total - self.bankPayments[0].amount_payment)
                var amountAdd = (accounting.unformat(amountPayments.val(),currencyJournal.decimal_separator));

                if (amountTotal <  amountAdd) {
                    openerp.web.notification.do_warn("Atencion", "El valor ingresado supera el monto a devolver.");
                    amountPayments.css('border-color','red');
                    amountPayments.focus();
                }

                amountPayments.val(accounting.formatNumber(amountAdd, currencyJournal.decimal_places, currencyJournal.thousands_separator, currencyJournal.decimal_separator));
            });


            /* Aceptar */
            addReceipt.click(function(e) {
                var amount = (accounting.unformat(amountPayments.val(),currencyJournal.decimal_separator));
                rejectPayments = [];

                /* Esperar pago */
                if (!!waitPaymentsChecked && !!waitPaymentsChecked.checked) {
                    if (!detailsReject.val()) {
                        openerp.web.notification.do_warn("Atencion", "Debes de ingresar el motivo del rechazo del cheque.");
                        detailsReject.css('border-color','red');
                        return;
                    }
                    detailsReject.css('border-color','#ccc');
                }

                /* Pagar el provvedor con otrometodo de pago */
                if (!!otherPaymentsChecked && !!otherPaymentsChecked.checked) {
                    /* Verificar si no fue selecioado el methodo de  pagos*/
                    if (!selectJournal.val()) {
                        openerp.web.notification.do_warn("Atencion", "Tienes que seleccionar el método de pago.");
                        selectJournal.css('border-color','red');
                        return;
                    }
                    selectJournal.css('border-color','#ccc');

                    if (amount < 0) {
                        openerp.web.notification.do_warn("Atencion", "Debes ingresar un monto a pagar.");
                        amountPayments.css('border-color','red');
                        return;
                    }
                    amountPayments.css('border-color','#ccc');

                    if ((self.bankPaymentsTotal[0].amountPayments - amount > 0.00) && (self.bankPaymentsTotal[0].amountPayments - amount < 0.11)) {
                        amount = self.bankPaymentsTotal[0].amountPayments;
                    }

                    /* descripción */
                    if (!detailsReject.val()) {
                        openerp.web.notification.do_warn("Atencion", "Debes de ingresar el motivo del rechazo del cheque.");
                        detailsReject.css('border-color','red');
                        return;
                    }
                    detailsReject.css('border-color','#ccc');
                }

                rejectPayments = {
                        'id': self.id,
                        'details': detailsReject.val(),
                        'amountPayments': amount,
                        'selectJournal':selectJournal.val(),
                        'waitPayments': !!waitPaymentsChecked ? waitPaymentsChecked.checked : false,
                        'otherPayments': !!otherPaymentsChecked ? otherPaymentsChecked.checked : false
                }

                self.bankPaymentsReject(rejectPayments).then(function(resultsReject) {
                    return resultsReject;
                }).then(function(resultsReject) {
                    self.reloadPage();
                    if (!resultsReject)
                        results = false;
                });

                defer.resolve(results);
                self.removeModal(e);
            });

            return defer;
        },
        /* Generar Cobro */
        bankPaymentsReject: function(rejectPayments) {
            var self = this;
            var defer = $.Deferred();
            var bankPayments = new openerp.web.Model('res.bank.payments');
            bankPayments.call('bank_payments_reject',[rejectPayments], {
                    context: new openerp.web.CompoundContext()
            }).then(function(results){
                    defer.resolve(results);
            });

            return defer;
        },

    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'res.bank.payments')
                    return;

                openerp.parentInstanceReject = this;

                if (openerp.widgetInstanceReject) {
                    openerp.widgetInstanceReject.checkState(record.id, record.state);
                    if (this.$el.find('.paymnet-reject').length !== 0)
                        return;
                }

                if (this.$el.find('.paymnet-reject').length !== 0 )
                    return;

                openerp.widgetInstanceReject = new openerp.BankPaymentsReject(this);

                var element =this.$el.find('.oe_form').find('.bank-paymnets-bank');

                openerp.widgetInstanceReject.appendTo(element[0]);
                openerp.widgetInstanceReject.checkState(record.id, record.state);
            }
        });
    }
})();
