(function() {

    openerp.widgetInstanceRenegotiate = null;
    openerp.parentInstanceRenegotiate = {};
    var QWeb = openerp.web.qweb;

    openerp.BankPaymentsRenegotiate = openerp.Widget.extend({
        template: 'bank_payments.Renegotiate',
        id: undefined,
        buttons: undefined,
        bankPayments: [],
        bankPaymentsLine: [],
        accountJournal: [],
        resCompany: [],
        resCurrency: [],
        currencySelect: [],
        bankPaymentsTotal: [],
        typeOperation: 'renegotiated',
        refPayments: 'Balance/cheque renegociado/',
        /* init */
        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        /* start */
        start: function () {
            var self = this;
            this.$el.find('.bank-payments-renegotiate').click(function() {
                self.fetchInitial();
            });
            self.buttons.click(function(e) {
                /* C (Crear) */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
            });
        },
        /* Check state*/
        checkState: function(id, state) {
            var self = this;
            self.id = id;
            this.$el.find('.bank-payments-renegotiate').css('display','flex');
            if ((state !== 'rejected')) {
                this.$el.find('.bank-payments-renegotiate').css('display','none');
            }
        },
        /* reloadPage */
        reloadPage: function() {
             openerp.parentInstanceRenegotiate.reload();
        },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Método inicial  */
        fetchInitial: function() {
            var self = this;
            self.fetchBankPayments(self.id).then(function(bankPayments) {
                return bankPayments;
            }).then(function(bankPayments) {
                self.bankPayments = bankPayments;
                return self.fetchBankPaymentsLine(self.id);
            }).then(function(bankPaymentsLine) {
                self.bankPaymentsLine = bankPaymentsLine;
                return  self.fetchACcountJournal();
            }).then(function(accountJournal) {
                self.accountJournal = accountJournal;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany ;
                return self.fetchResCurrency()
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.generateBankPaymentsTotal();
            }).then(function(bankPaymentsTotal) {
                self.bankPaymentsTotal = bankPaymentsTotal;
                return self.showModalReject();
            });
        },
        /* bank payments */
        fetchBankPayments: function(id) {
            var bankPaymnets = new openerp.web.Model('res.bank.payments');
            var fields = ['id', 'state', 'payments_line', 'amount_receipt', 'amount_payment', 'amount_total','currency_id','bank_payments_type_id','name_holder', 'number_cta', 'number', 'date_maturity'];
            var domain = [['id', '=', id]];
            return bankPaymnets.query(fields).filter(domain).all();
        },
        /* Bank Paymnets line*/
        fetchBankPaymentsLine: function(bankPaymnetId) {
            var paymentLine = new openerp.web.Model('res.bank.payments.line');
            var fields = ['id', 'amount','type_operation', 'bank_payments_id'];
            var domain = [['bank_payments_id', '=', bankPaymnetId],['type_operation', 'in', ['payment', 'receipt']]];
            return paymentLine.query(fields).filter(domain).all();
        },
        /*Account Journal  */
        fetchACcountJournal: function() {
            var fields = ['id', 'name', 'code', 'type', 'currency', 'default_debit_account_id', 'default_credit_account_id'];
            var domain = [['active', '=', true], ['type', 'in', ['bank', 'cash']], ['currency', '=', false]];
            var journalSalario = new openerp.web.Model('account.journal');
            return journalSalario.query(fields).filter(domain).all();
        },
        /* Consultar Compania */
        fetchResCompany: function() {
            var fields = ['id','name', 'currency_id'];
            var domain = [['id', '=', 1]];
            var resCompanyIds = new openerp.web.Model('res.company');
            return resCompanyIds.query(fields).filter(domain).all();
        },
        /* Consultar Moneda Activas */
        fetchResCurrency : function() {
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position', 'rate'];
            var domain = [['active','=', true]];
            var resCurrecy = new openerp.web.Model('res.currency');
            return resCurrecy.query(fields).filter(domain).all();
        },
        generateBankPaymentsTotal: function(){
            var self = this;
            var  renegotiateTotal = 0;
            var  paymnetTotal = 0;
            var  receiptTotal = 0;
            var  bankPaymentsTotal = [];
            var bankPayments = self.bankPayments[0];

            self.currencySelect = self.getCurrency(bankPayments.currency_id[0]).shift();
            _.each(self.bankPaymentsLine, function(line) {
                /*receipt*/
                if (line.type_operation === 'receipt')
                    receiptTotal += line.amount;
                /*Payments*/
                if (line.type_operation === 'payment')
                    paymnetTotal += line.amount;
                /* Renegotiate*/
                if (line.type_operation === 'renegotiated')
                    renegotiateTotal += line.amount;
            });

            bankPaymentsTotal.push({
                'amountReceipt': bankPayments.amount_total - renegotiateTotal,
                'amountReceiptFormat': accounting.formatNumber((bankPayments.amount_total - renegotiateTotal), self.currencySelect.decimal_places, self.currencySelect.thousands_separator, self.currencySelect.decimal_separator),
                'paymnetTotal': paymnetTotal,
                'paymnetTotalFormat': accounting.formatNumber((paymnetTotal), self.currencySelect.decimal_places, self.currencySelect.thousands_separator, self.currencySelect.decimal_separator),
                'receiptTotal': receiptTotal,
                'receiptTotalFormat': accounting.formatNumber((receiptTotal), self.currencySelect.decimal_places, self.currencySelect.thousands_separator, self.currencySelect.decimal_separator),
                'currencySymbol': self.currencySelect.symbol,
                'date': moment().format('DD/MM/YYYY'),
                'rate': self.currencySelect.rate
            });

            return bankPaymentsTotal;
        },
        /* Get Currency*/
        getCurrency: function(id) {
            var self = this;
            return _.filter(self.resCurrency, function(item) {
                return item.id === id;
            });
        },
        /* Get Journal*/
        getJournal: function(code) {
            var self = this;
            return _.filter(self.accountJournal, function(item) {
                return item.code === code;
            });
        },
        /* Select Journal Change */
        getSelectedJournal: function(code, company){
            var self = this;
            var journal = self.getJournal(code).shift();
            var company = self.resCompany;

            if (!journal)
                return [];

            if (!journal.currency) {
                self.currencySelect = self.getCurrency(company[0].currency_id[0]);
            }else {
                self.currencySelect = self.getCurrency(journal.currency[0]);
            }

            return !!self.currencySelect ? self.currencySelect : [];
        },
        /* Recalcule Receipt*/
        recalculateReceipt: function(currencySelect, bankPaymentsReceipt) {
            var self = this;
            var changeCurrency = [];
            var  renegotiateTotal = 0;
            var  paymnetTotal = 0;
            var  receiptTotal = 0;
            if (!currencySelect || !bankPaymentsReceipt)
                return;

            renegotiateTotal = (bankPaymentsReceipt.amountReceipt * (currencySelect.rate / bankPaymentsReceipt.rate));
            paymnetTotal = (bankPaymentsReceipt.paymnetTotal * (currencySelect.rate / bankPaymentsReceipt.rate));
            receiptTotal = (bankPaymentsReceipt.receiptTotal * (currencySelect.rate / bankPaymentsReceipt.rate));

            changeCurrency.push({
                'amountReceipt': renegotiateTotal,
                'amountReceiptFormat': accounting.formatNumber((renegotiateTotal), currencySelect.decimal_places, currencySelect.thousands_separator, currencySelect.decimal_separator),
                'paymnetTotal': paymnetTotal,
                'paymnetTotalFormat': accounting.formatNumber((paymnetTotal), currencySelect.decimal_places, currencySelect.thousands_separator, currencySelect.decimal_separator),
                'receiptTotal': receiptTotal,
                'receiptTotalFormat': accounting.formatNumber((receiptTotal), currencySelect.decimal_places, currencySelect.thousands_separator, currencySelect.decimal_separator),
                'currencySymbol': currencySelect.symbol,
                'date': moment().format('DD/MM/YYYY'),
                'rate': currencySelect.rate
            });

            self.bankPaymentsTotal = changeCurrency;
            return changeCurrency;
        },
        // /* Modal */
        showModalReject: function() {
            var self = this;
            var defer =$.Deferred();
            var results = true;
            var currencyJournal = [];
            var newAmountReceipt = [];
            var bankPayments = self.bankPayments[0];
            var currencyBankPayments = self.getCurrency(bankPayments.currency_id[0]).shift();

            // self.separatePaymentLine(self.bankPaymentsLine);

            var modal = QWeb.render('bank_payments.ModalRenegotiateWidget',{
                journal: self.accountJournal,
                bankPaymentsTotal: self.bankPaymentsTotal
            });

            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();
            /* Cerrar */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });
            /** amount_total */
            var amountTotal = $('.expired-account-modal').find('.amount-total');
            var symbolAmountTotal = $('.expired-account-modal').find('.symbol-amount-total');
            /*  receipt */
            var receiptTotal = $('.expired-account-modal').find('.receipt-total');
            var symbolReceiptTotal = $('.expired-account-modal').find('.symbol-receipt-total');
            /*  payments */
            var paymentTotal = $('.expired-account-modal').find('.payment-total');
            var symbolPaymentTotal = $('.expired-account-modal').find('.symbol-payment-total');
            /*  radio */
            var checkRadio = $('.expired-account-modal').find('.check-radio');
            var otherRadio = $('.expired-account-modal').find('.other-radio');
            var checkCashingRadio = $('.expired-account-modal').find('.check-cashing-radio');
            /* renegociación */
            var detailsRenegotiate = $('.expired-account-modal').find('.details-renegotiate');
            var selectInput = $('.expired-account-modal').find('.select-input');

            var amountPayments = $('.expired-account-modal').find('.amount-payments');
            var symbolAmountPayments = $('.expired-account-modal').find('.symbol-amount-payments');
            /* Cambio de cheque */
            var checkNameHolder = $('.expired-account-modal').find('.check-name-holder')
            var checkNumberCta = $('.expired-account-modal').find('.check-number-cta')
            var checkNumber = $('.expired-account-modal').find('.check-number')
            var checkDateMaturity = $('.expired-account-modal').find('.check-date-maturity')
            var checkAmountTotal = $('.expired-account-modal').find('.check-amount-total')
            var checkAmountTotalSymbol = $('.expired-account-modal').find('.check-amount-total-symbol')

            var buttonAccept = $('.expired-account-modal').find('.button-accept');

            var clickcheck = null;
            var clicOther = null;
            var clickCheckCashing = null;
            /* select check*/
            checkRadio.click(function(e) {
                clickcheck = e.target;
                $('.expired-account-modal').find('.details-paymnets-renegotiate-otres').css('display','none');
                $('.expired-account-modal').find('.details-paymnets-renegotiate-check-cashing').css('display','none');
                if (this.checked) {
                    $('.expired-account-modal').find('.details-paymnets-renegotiate').css('display','flex');
                    if (clicOther)
                        clicOther.checked= false;
                    if (clickCheckCashing)
                        clickCheckCashing.checked= false;

                    newAmountReceipt = self.generateBankPaymentsTotal();
                    if (!!newAmountReceipt.length) {
                        amountTotal.val(newAmountReceipt[0].amountReceiptFormat);
                        symbolAmountTotal.text(newAmountReceipt[0].currencySymbol);
                        receiptTotal.val(newAmountReceipt[0].receiptTotalFormat);
                        symbolReceiptTotal.text(newAmountReceipt[0].currencySymbol);
                        paymentTotal.val(newAmountReceipt[0].paymnetTotalFormat);
                        symbolPaymentTotal.text(newAmountReceipt[0].currencySymbol);
                        amountPayments.val(newAmountReceipt[0].amountReceiptFormat);
                        symbolAmountPayments.text(newAmountReceipt[0].currencySymbol);
                    }
                } else {
                    $('.expired-account-modal').find('.details-paymnets-renegotiate').css('display','none');
                }
                /* Limpiar */
                detailsRenegotiate.val("");
                // amountPayments.val('0');
                detailsRenegotiate.css('border-color','#ccc');
                detailsRenegotiate.css('border-color','#ccc');
                selectInput.css('border-color','#ccc');
            });
            /* Select other*/
            otherRadio.click(function(e) {
                clicOther =e.target;
                $('.expired-account-modal').find('.details-paymnets-renegotiate-check-cashing').css('display','none');
                if (this.checked){
                    $('.expired-account-modal').find('.details-paymnets-renegotiate').css('display','flex');
                    $('.expired-account-modal').find('.details-paymnets-renegotiate-otres').css('display','flex');
                    if (clickcheck)
                        clickcheck.checked= false;
                    if (clickCheckCashing)
                        clickCheckCashing.checked= false;

                } else {
                    $('.expired-account-modal').find('.details-paymnets-renegotiate').css('display','none');
                    $('.expired-account-modal').find('.details-paymnets-renegotiate-otres').css('display','none');

                    newAmountReceipt = self.generateBankPaymentsTotal();
                    if (!!newAmountReceipt.length) {
                        amountTotal.val(newAmountReceipt[0].amountReceiptFormat);
                        symbolAmountTotal.text(newAmountReceipt[0].currencySymbol);
                        receiptTotal.val(newAmountReceipt[0].receiptTotalFormat);
                        symbolReceiptTotal.text(newAmountReceipt[0].currencySymbol);
                        paymentTotal.val(newAmountReceipt[0].paymnetTotalFormat);
                        symbolPaymentTotal.text(newAmountReceipt[0].currencySymbol);
                        amountPayments.val(newAmountReceipt[0].amountReceiptFormat);
                        symbolAmountPayments.text(newAmountReceipt[0].currencySymbol);
                    }
                }
                detailsRenegotiate.val("");

                detailsRenegotiate.css('border-color','#ccc');
                detailsRenegotiate.css('border-color','#ccc');
                selectInput.css('border-color','#ccc');
            });
            /*Cambio de chqeques */
            checkCashingRadio.click(function(e){
                clickCheckCashing = e.target;
                $('.expired-account-modal').find('.details-paymnets-renegotiate-otres').css('display','none');
                if (this.checked) {
                    $('.expired-account-modal').find('.details-paymnets-renegotiate-check-cashing').css('display','flex');
                    $('.expired-account-modal').find('.details-paymnets-renegotiate').css('display','flex');
                    /* Reintegrar Cheque*/
                    if (clickcheck)
                        clickcheck.checked= false;
                    /* Otro método de pago  */
                    if (clicOther)
                        clicOther.checked= false;

                    if (bankPayments) {
                        checkNameHolder.val(bankPayments.name_holder);
                        checkNumberCta.val(bankPayments.number_cta);
                        checkNumber.val(bankPayments.number);
                        checkDateMaturity.val(bankPayments.date_maturity);
                        checkAmountTotal.val(accounting.formatNumber(bankPayments.amount_total, currencyBankPayments.decimal_places, currencyBankPayments.thousands_separator, currencyBankPayments.decimal_separator));
                        checkAmountTotalSymbol.text(currencyBankPayments.symbol);
                    }

                } else {
                    $('.expired-account-modal').find('.details-paymnets-renegotiate-check-cashing').css('display','none');
                    $('.expired-account-modal').find('.details-paymnets-renegotiate').css('display','none');
                    $('.expired-account-modal').find('.details-paymnets-renegotiate-otres').css('display','none');
                }

            });
            /* Recalcular el vuelto según el diario seleccionado */
            currencyJournal = self.getSelectedJournal(selectInput.val()).shift();
            newAmountReceipt = self.recalculateReceipt(currencyJournal, self.bankPaymentsTotal[0]);

            if (!!newAmountReceipt.length) {
                amountTotal.val(newAmountReceipt[0].amountReceiptFormat);
                symbolAmountTotal.text(newAmountReceipt[0].currencySymbol);
                receiptTotal.val(newAmountReceipt[0].receiptTotalFormat);
                symbolReceiptTotal.text(newAmountReceipt[0].currencySymbol);
                paymentTotal.val(newAmountReceipt[0].paymnetTotalFormat);
                symbolPaymentTotal.text(newAmountReceipt[0].currencySymbol);
                amountPayments.val(newAmountReceipt[0].amountReceiptFormat);
                symbolAmountPayments.text(newAmountReceipt[0].currencySymbol);
            }
            /* change Journal */
            selectInput.change(function(e) {
                /* Recalcular el vuelto según el diario seleccionado */
                currencyJournal = self.getSelectedJournal(selectInput.val()).shift();
                newAmountReceipt = self.recalculateReceipt(currencyJournal, self.bankPaymentsTotal[0]);
                if (!!newAmountReceipt.length) {
                    amountTotal.val(newAmountReceipt[0].amountReceiptFormat);
                    symbolAmountTotal.text(newAmountReceipt[0].currencySymbol);
                    receiptTotal.val(newAmountReceipt[0].receiptTotalFormat);
                    symbolReceiptTotal.text(newAmountReceipt[0].currencySymbol);
                    paymentTotal.val(newAmountReceipt[0].paymnetTotalFormat);
                    symbolPaymentTotal.text(newAmountReceipt[0].currencySymbol);
                    amountPayments.val(newAmountReceipt[0].amountReceiptFormat);
                    symbolAmountPayments.text(newAmountReceipt[0].currencySymbol);
                }
            });
            /* Click button */
            buttonAccept.click(function(e) {
                currencyJournal = self.getSelectedJournal(selectInput.val()).shift();
                var renegotiateReceipt = (accounting.unformat(amountTotal.val(),currencyJournal.decimal_separator));
                var paymnetsAmount = (accounting.unformat(amountPayments.val(),currencyJournal.decimal_separator));
                var newAmountTotal = (accounting.unformat(checkAmountTotal.val(),currencyBankPayments.decimal_separator));
                var renegotiate = [];
                /* Verificar si no fue seleccionado ninguna forma de renegociacion*/
                if  ((!clickcheck || !clickcheck.checked) && (!clicOther || !clicOther.checked) && (!clickCheckCashing || !clickCheckCashing.checked)) {
                    openerp.web.notification.do_warn("Atencion", "Tiene que seleccionar la forma de renegociacion.");
                    return;
                }
                /* Verificar si fue seleccionado Reintegrar Cheque */
                if (!!clickcheck && !!clickcheck.checked) {
                    /* Verificar si no fue ingresado una descripción*/
                    if (!detailsRenegotiate.val()) {
                        openerp.web.notification.do_warn("Atencion", "Tienes que ingresar una descripción  para la reintegración del cheque.");
                        detailsRenegotiate.css('border-color','red');
                        return;
                    }
                    detailsRenegotiate.css('border-color','#ccc');
                }
                /* Verificar si fue seleccionado Otro método de pago */
                if (!!clicOther && !!clicOther.checked) {
                    /* Verificar si no fue ingresado una descripción*/
                    if (!detailsRenegotiate.val()) {
                        openerp.web.notification.do_warn("Atencion", "Tienes que ingresar una descripción  para la reintegración del cheque.");
                        detailsRenegotiate.css('border-color','red');
                        return;
                    }
                    detailsRenegotiate.css('border-color','#ccc');

                    /* Verificar si no fue selecioado el methodo de  pagos*/
                    if (!selectInput.val()) {
                        openerp.web.notification.do_warn("Atencion", "Tienes que seleccionar el método de pago.");
                        selectInput.css('border-color','red');
                        return;
                    }
                    selectInput.css('border-color','#ccc');

                    /* Verificar sin no fue ingresado el montoa a pagar */
                    if (!amountPayments.val()) {
                        openerp.web.notification.do_warn("Atencion", "Tienes que ingresa el monto a pagar.");
                        detailsRenegotiate.css('border-color','red');
                        return;
                    }
                    amountPayments.css('border-color','#ccc');
                }
                /* Verificar si fue seleconado Cambio de cheque */
                if (!!clickCheckCashing && !!clickCheckCashing.checked) {
                    if (!checkNameHolder.val()) {
                        openerp.web.notification.do_warn("Atencion", "Debes ingresar el nombre del titular del cheque.");
                        checkNameHolder.css('border-color','red');
                        return;
                    }
                    checkNameHolder.css('border-color','#ccc');

                    if (!checkNumberCta.val()) {
                        openerp.web.notification.do_warn("Atencion", "El numero de cuenta es obligatorio.");
                        checkNumberCta.css('border-color','red');
                        return;
                    }
                    checkNumberCta.css('border-color','#ccc');

                    if (!checkNumber.val()) {
                        openerp.web.notification.do_warn("Atencion", "El numero de cheques es obligatorio.");
                        checkNumber.css('border-color','red');
                        return;
                    }
                    checkNumber.css('border-color','#ccc');

                    if (!checkDateMaturity.val()) {
                        openerp.web.notification.do_warn("Atencion", "Debes ingresar la fecha de vencimiento del cheque.");
                        checkDateMaturity.css('border-color','red');
                        return;
                    }
                    checkDateMaturity.css('border-color','#ccc');

                    if (newAmountTotal <= 0) {
                        openerp.web.notification.do_warn("Atencion", "El monto del cheque no puede ser 0.");
                        checkAmountTotal.css('border-color','red');
                        return;
                    }
                    if (newAmountTotal <  bankPayments.amount_total) {
                        var bankTotal = accounting.formatNumber(bankPayments.amount_total, currencyBankPayments.decimal_places, currencyBankPayments.thousands_separator, currencyBankPayments.decimal_separator);
                        openerp.web.notification.do_warn("Atencion", "El nuevo valor del cheque debes de ser mayor o igual al valor anterior  ("+bankTotal+" "+currencyBankPayments.symbol+").");
                        checkAmountTotal.css('border-color','red');
                        return;
                    }
                    checkAmountTotal.css('border-color','#ccc');

                    /* Verificar si no fue ingresado una descripción*/
                    if (!detailsRenegotiate.val()) {
                        openerp.web.notification.do_warn("Atencion", "Tienes que ingresar una descripción  para la reintegración del cheque.");
                        detailsRenegotiate.css('border-color','red');
                        return;
                    }
                    detailsRenegotiate.css('border-color','#ccc');
                }

                renegotiate = {
                    'checkRadio': !!clickcheck ? clickcheck.checked : false,
                    'otherRadio': !!clicOther ? clicOther.checked : false,
                    'CheckCashingRadio': !!clickCheckCashing ? clickCheckCashing.checked : false,
                    'detailsRenegotiate': detailsRenegotiate.val() ,
                    'selectInput': selectInput.val(),
                    'amountPayments': paymnetsAmount,
                    'id': self.id,
                    'typeOperation': self.typeOperation,
                    'refPayments': self.refPayments,
                    'details' : 'Renegociación',
                    'number': !!checkNumber.val() ? checkNumber.val() :bankPayments.number,
                    'amountTotal': newAmountTotal > 0 ? newAmountTotal : bankPayments.amount_total,
                    'dateMaturity': !!checkDateMaturity.val() ? checkDateMaturity.val() :bankPayments.date_maturity,
                    'numberCta': !!checkNumberCta.val() ?checkNumberCta.val() :bankPayments.number_cta,
                    'nameHolder': !!checkNameHolder.val() ?checkNameHolder.val() :bankPayments.name_holder
                };

                self.bankPaymentsRenegotiate(renegotiate).then(function(resultsRenegotiate) {
                    return resultsRenegotiate;
                }).then(function(resultsRenegotiate) {
                    self.reloadPage();
                    if (!resultsRenegotiate)
                        results = false;

                });

                defer.resolve(results);
                self.removeModal(e);
            });

            return defer;
        },
        /* */
        //
        bankPaymentsRenegotiate: function(renegotiate){
            var self = this;
            var defer = $.Deferred();
            var bankPayments = new openerp.web.Model('res.bank.payments');
            bankPayments.call('bank_payments_renegotiate',[renegotiate], {
                    context: new openerp.web.CompoundContext()
            }).then(function(results){
                    defer.resolve(results);
            });

            return defer;
        },
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'res.bank.payments')
                    return;

                openerp.parentInstanceRenegotiate = this;

                if (openerp.widgetInstanceRenegotiate) {
                    openerp.widgetInstanceRenegotiate.checkState(record.id, record.state);
                    if (this.$el.find('.paymnet-renegotiate').length !== 0)
                        return
                }

                if (this.$el.find('.paymnet-renegotiate').length !== 0)
                    return;

                openerp.widgetInstanceRenegotiate = new openerp.BankPaymentsRenegotiate(this);

                var element =this.$el.find('.oe_form').find('.bank-paymnets-bank');

                openerp.widgetInstanceRenegotiate.appendTo(element[0]);
                openerp.widgetInstanceRenegotiate.checkState(record.id, record.state);
            }
        });
    }
})();
