(function() {

    openerp.widgetInstanceSupplierReturned = null;
    openerp.parentInstanceSupplierReturned = {};
    var QWeb = openerp.web.qweb;

    openerp.BankPaymentsSupplierReturned = openerp.Widget.extend({
        template: 'bank_payments.SupplierReturnedWidget',
        id: undefined,
        buttons: undefined,
        bankPayments: [],
        bankPaymentsLine: [],
        accountJournal: [],
        resCompany: [],
        resCurrency: [],
        currencySelect: [],
        bankPaymentsReceipt: [],
        // typeOperation: 'payment',
        typeOperation: 'receipt',
        refPayments: 'Balance/recibido de proveedor/',
        messageError: '',
        /* init */
        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        /* start */
        start: function () {
            var self = this;
            this.$el.find('.bank-payments-supplier').click(function() {
                self.fetchInitial();
            });
            self.buttons.click(function(e) {
                /* C (Crear) */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
            });
        },
        /* Check state*/
        checkState: function(id, state) {
            var self = this;
            self.id = id;
            this.$el.find('.bank-payments-supplier').css('display','flex');
            if (state !== 'available'){
                this.$el.find('.bank-payments-supplier').css('display','none');
            }
        },
        /* reloadPage */
        reloadPage: function() {
             openerp.parentInstanceSupplierReturned.reload();
        },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Método inicial  */
        fetchInitial: function() {
            var self = this;
            var status = true;
            self.fetchBankPayments(self.id).then(function(bankPayments) {
                return bankPayments;
            }).then(function(bankPayments) {
                self.bankPayments = bankPayments;
                return self.fetchBankPaymentsLine(self.id, self.typeOperation);
            }).then(function(bankPaymentsLine) {
                self.bankPaymentsLine = bankPaymentsLine;
                if (!self.bankPaymentsLine.length){
                    openerp.web.notification.do_warn("Atencion", "El cheque no cuenta con ningún pagos a proveedores" );
                    status = false;
                }
                return self.fetchACcountJournal();
            }).then(function(accountJournal) {
                self.accountJournal = accountJournal;
                return self.fetchResCompany();
            }).then(function(resCompany) {
                self.resCompany = resCompany;
                return self.fetchResCurrency();
            }).then(function(resCurrency) {
                self.resCurrency = resCurrency;
                return self.generateReturned();
            }).then(function(bankPaymentsReceipt) {
                self.bankPaymentsReceipt = bankPaymentsReceipt;
                if (!self.bankPaymentsReceipt.length) {
                    openerp.web.notification.do_warn("Atencion", self.messageError);
                    status = false;
                }
                return self.fetchBankPaymentsLine(self.id, 'receipt');
            }).then(function(lineReceipt) {
                if (!!lineReceipt.length) {
                    var amount = 0;
                    _.each(lineReceipt, function(item) {
                        amount += item.amount;
                    });
                    if (self.bankPaymentsReceipt[0].amountReceipt > amount) {
                        openerp.web.notification.do_warn("Atencion", "EL cheque aun tiene  moto a devolver" );
                        status = false;
                    }
                }
                if (status)
                    return self.showModalReturned();
            });
        },
        /* bank payments */
        fetchBankPayments: function(id) {
            var bankPaymnets = new openerp.web.Model('res.bank.payments');
            var fields = ['id', 'state', 'payments_line', 'amount_receipt', 'amount_payment', 'amount_total','currency_id'];
            var domain = [['id', '=', id]];
            return bankPaymnets.query(fields).filter(domain).all();
        },
        /* Bank Paymnets line*/
        fetchBankPaymentsLine: function(bankPaymnetId, typeOperation) {
            var paymentLine = new openerp.web.Model('res.bank.payments.line');
            var fields = ['id', 'amount','type_operation', 'bank_payments_id'];
            var domain = [['bank_payments_id', '=', bankPaymnetId],['type_operation','=', typeOperation]];
            return paymentLine.query(fields).filter(domain).all();
        },
        /*Account Journal  */
        fetchACcountJournal: function() {
            var fields = ['id', 'name', 'code', 'type', 'currency', 'default_debit_account_id', 'default_credit_account_id'];
            var domain = [['active', '=', true], ['type', 'in', ['bank', 'cash']]];
            var journalSalario = new openerp.web.Model('account.journal');
            return journalSalario.query(fields).filter(domain).all();
        },
        /* Consultar Compania */
        fetchResCompany: function() {
            var fields = ['id','name', 'currency_id'];
            var domain = [['id', '=', 1]];
            var resCompanyIds = new openerp.web.Model('res.company');
            return resCompanyIds.query(fields).filter(domain).all();
        },
        /* Consultar Moneda Activas */
        fetchResCurrency : function() {
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position', 'rate'];
            var domain = [['active','=', true]];
            var resCurrecy = new openerp.web.Model('res.currency');
            return resCurrecy.query(fields).filter(domain).all();
        },
        /* Generar Vuelto  */
        generateReturned: function() {
            var self = this;
            var bankPayments = self.bankPayments.shift();
            var  amountReceipt = 0;
            var  bankPaymentsReceipt = [];
            self.messageError= "No tienes nada que devolver.";

            if(!bankPayments.customer_id) {
                self.messageError= "Tienes que indicar de quien recibiste el documento.";
                return false ;
            }

            if (bankPayments.state != "available")
                return false;

            self.currencySelect = self.getCurrency(bankPayments.currency_id[0]).shift();
            if (!self.currencySelect){
                self.messageError= "Tienes que seleccionar la moneda de la operación.";
                return false ;
            }
            _.each(self.bankPaymentsLine, function(item){
                amountReceipt += item.amount;
            });

            if (bankPayments.amount_total - amountReceipt <= 0)
                return false;

            bankPaymentsReceipt.push({
                'amountReceipt': bankPayments.amount_total - amountReceipt,
                'amountFormat': accounting.formatNumber((bankPayments.amount_total - amountReceipt), self.currencySelect.decimal_places, self.currencySelect.thousands_separator, self.currencySelect.decimal_separator),
                'currencySymbol': self.currencySelect.symbol,
                'date': moment().format('DD/MM/YYYY'),
                'rate': self.currencySelect.rate
            });

            return bankPaymentsReceipt;
        },
        /* Recalcule Receipt*/
        recalculateReceipt: function(currencySelect, bankPaymentsReceipt){
            var self = this;
            var changeCurrency = [];
            var amountReceipt = 0;
            if (!currencySelect || !bankPaymentsReceipt)
                return;

            amountReceipt = (bankPaymentsReceipt.amountReceipt * (currencySelect.rate / bankPaymentsReceipt.rate));

            changeCurrency.push({
                'amountReceipt': amountReceipt,
                'amountFormat': accounting.formatNumber((amountReceipt), currencySelect.decimal_places, currencySelect.thousands_separator, currencySelect.decimal_separator),
                'currencySymbol': currencySelect.symbol,
                'date': moment().format('DD/MM/YYYY'),
                'rate': currencySelect.rate
            });
            self.bankPaymentsReceipt = changeCurrency;
            return changeCurrency;
        },
        /* Get Currency*/
        getCurrency: function(id) {
            var self = this;
            return _.filter(self.resCurrency, function(item) {
                return item.id === id;
            });
        },
        /* Get Journal*/
        getJournal: function(code) {
            var self = this;
            return _.filter(self.accountJournal, function(item) {
                return item.code === code;
            });
        },
        /* Select Journal Change */
        getSelectedJournal: function(code, company) {
            var self = this;
            var journal = self.getJournal(code).shift();
            var company = self.resCompany;

            if (!journal)
                return [];

            if (!journal.currency) {
                self.currencySelect = self.getCurrency(company[0].currency_id[0]);
            }else {
                self.currencySelect = self.getCurrency(journal.currency[0]);
            }

            return !!self.currencySelect ? self.currencySelect : [];
        },
        /* Generar Balance */
        balanceBankPaymentsCustomers: function(selectJournal,amountReceipt) {
            var self = this;
            var defer = $.Deferred();
            var bankPayments = new openerp.web.Model('res.bank.payments');

            bankPayments.call('balance_bank_payments',[
                {
                    id: self.id,
                    amountReceipt: amountReceipt,
                    selectJournal: selectJournal,
                    typeOperation: self.typeOperation,
                    refPayments: self.refPayments,
                    details: 'Vuelto'
                }
            ], {
                    context: new openerp.web.CompoundContext()
            }).then(function(results){
                    defer.resolve(results);
            });

            return defer;
        },
        /* Receipt */
        showModalReturned: function() {
            var self = this;
            var defer =$.Deferred();
            var results = true;
            var currencyJournal = [];
            var newAmountReceipt = [];

            var modal = QWeb.render('bank_payments.ModalReturnedWidget' ,{
                journal: self.accountJournal,
                bankPaymentsReceipt: self.bankPaymentsReceipt,
            });

            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();
            /* Cerrar */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });
            /* Receipt */
            var inputAmountReceiptTotal = $('.expired-account-modal').find('.amount-receipt-total');
            var symbolAmountReceiptTotal = $('.expired-account-modal').find('.symbol-receipt-total');
            /* Monto*/
            var inputAmountReceipt = $('.expired-account-modal').find('.amount-receipt');
            var symbolAmountReceipt = $('.expired-account-modal').find('.symbol-receipt');
            /* Jouanl */
            var selectJournal = $('.expired-account-modal').find('.select-input');
            /* Aceptar */
            var addReceipt = $('.expired-account-modal').find('.add-receipt');

            /* Recalcular el vuelto según el diario seleccionado */
            currencyJournal = self.getSelectedJournal(selectJournal.val()).shift();

            newAmountReceipt = self.recalculateReceipt(currencyJournal, self.bankPaymentsReceipt.shift());

            if (!!newAmountReceipt.length) {
                inputAmountReceipt.val(newAmountReceipt[0].amountFormat);
                symbolAmountReceipt.text(newAmountReceipt[0].currencySymbol);
                inputAmountReceiptTotal.val(newAmountReceipt[0].amountFormat);
                symbolAmountReceiptTotal.text(newAmountReceipt[0].currencySymbol);
            }
            /* change Journal */
            selectJournal.change(function(e) {
                /* Recalcular el vuelto según el diario seleccionado */
                currencyJournal = self.getSelectedJournal(selectJournal.val()).shift();
                newAmountReceipt = self.recalculateReceipt(currencyJournal, self.bankPaymentsReceipt.shift());
                if (!!newAmountReceipt.length) {
                    inputAmountReceipt.val(newAmountReceipt[0].amountFormat);
                    symbolAmountReceipt.text(newAmountReceipt[0].currencySymbol);
                    inputAmountReceiptTotal.val(newAmountReceipt[0].amountFormat);
                    symbolAmountReceiptTotal.text(newAmountReceipt[0].currencySymbol);
                }
            });
            /*Monto */
            inputAmountReceipt.keyup(function(e) {
                currencyJournal = self.getSelectedJournal(selectJournal.val()).shift();
                var amount_add = (accounting.unformat(inputAmountReceipt.val(),currencyJournal.decimal_separator));
                inputAmountReceipt.val(accounting.formatNumber(amount_add, 0, currencyJournal.thousands_separator, currencyJournal.decimal_separator));
                inputAmountReceipt.css('border-color','#ccc');

                if (e.keyCode === 13)
                    addReceipt.focus();
            });
            /* Monto */
            inputAmountReceipt.focusout(function(e) {
                currencyJournal = self.getSelectedJournal(selectJournal.val()).shift();
                var amountTotal = (accounting.unformat(inputAmountReceiptTotal.val(),currencyJournal.decimal_separator));
                var amountAdd = (accounting.unformat(inputAmountReceipt.val(),currencyJournal.decimal_separator));
                if (amountTotal <  amountAdd) {
                    openerp.web.notification.do_warn("Atencion", "El valor ingresado supera el monto a devolver.");
                    inputAmountReceipt.css('border-color','red');
                    inputAmountReceipt.focus();
                }
                inputAmountReceipt.val(accounting.formatNumber(amountAdd, currencyJournal.decimal_places, currencyJournal.thousands_separator, currencyJournal.decimal_separator));
            });

            /* Aceptar */
            addReceipt.click(function(e) {
                var amountTotal = (accounting.unformat(inputAmountReceiptTotal.val(),currencyJournal.decimal_separator));
                var amountReceipt = (accounting.unformat(inputAmountReceipt.val(),currencyJournal.decimal_separator));
                if (!selectJournal.val()) {
                    openerp.web.notification.do_warn("Atencion", "Debes seleccionar un método de pago para continuar.");
                    selectJournal.css('border-color','red');
                    return;
                }
                selectJournal.css('border-color','#ccc');
                if (amountReceipt <= 0) {
                    openerp.web.notification.do_warn("Atencion", "El monto ingresado no ser 0");
                    inputAmountReceipt.css('border-color','red');
                    return;
                }

                if (amountTotal < amountReceipt) {
                    openerp.web.notification.do_warn("Atencion", "El valor ingresado supera el monto a devolver.");
                    inputAmountReceipt.css('border-color','red');
                    return ;
                }
                inputAmountReceipt.css('border-color','#ccc');
                if ((self.bankPaymentsReceipt[0].amountReceipt - amountReceipt > 0.00) && (self.bankPaymentsReceipt[0].amountReceipt - amountReceipt < 0.11)) {
                    amountReceipt = self.bankPaymentsReceipt[0].amountReceipt;
                }

                self.balanceBankPaymentsCustomers(selectJournal.val(), amountReceipt).then(function(resultsBanalnce) {
                    return resultsBanalnce;
                }).then(function(resultsBanalnce) {
                    self.reloadPage();
                    if (!resultsBanalnce)
                        results = false;
                });

                defer.resolve(results);
                self.removeModal(e);
            });
            return defer;
        },
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'res.bank.payments')
                    return;

                openerp.parentInstanceSupplierReturned = this;

                if (openerp.widgetInstanceSupplierReturned) {
                    openerp.widgetInstanceSupplierReturned.checkState(record.id, record.state);
                    if (this.$el.find('.supplier-returned').length !== 0 )
                        return
                }

                if (this.$el.find('.supplier-returned').length !== 0 )
                    return;

                openerp.widgetInstanceSupplierReturned = new openerp.BankPaymentsSupplierReturned(this);

                var element =this.$el.find('.oe_form').find('.bank-paymnets-bank');

                openerp.widgetInstanceSupplierReturned.appendTo(element[0]);
                openerp.widgetInstanceSupplierReturned.checkState(record.id, record.state);
            }
        });
    }
})();
