(function() {

    openerp.widgetInstanceTypeConfig = null;
    openerp.parentInstanceTypeConfig = {};
    var QWeb = openerp.web.qweb;
    var typeFields = [
        {
            'type' : 'normal',
            'format': null,
            'fieldsType': 'char'
        },{
            'type' : 'normal',
            'format': null,
            'fieldsType': 'email'
        },{
            'type' : 'normal',
            'format': null,
            'fieldsType': 'text'
        },{
            'type' : 'normal',
            'format': "DD/MM/YYY",
            'fieldsType': 'date'
        },{
            'type' : 'normal',
            'format': "$ ###,###,###",
            'fieldsType': 'float'
        },{
            'type' : 'model',
            'format': null,
            'fieldsType': 'many2one'
        },{
            'type' : 'model',
            'format': null,
            'fieldsType': 'many2many'
        },{
            'type' : 'model',
            'format': null,
            'fieldsType': 'one2many'
        }
    ];
    var searchType =[
        {
            'code':'none',
            'name': 'No Buscar'
        },
        {
            'code':'selection',
            'name': 'Seleccionar'
        },
        // {
        //     'code':'dialog',
        //     'name': 'Dialogo'
        // },
        {
            'code':'autocomplete',
            'name': 'Auto completar'
        }
    ];

    openerp.BankPaymentsTypeConfig = openerp.Widget.extend({
        template: 'bank_payments.ConfigFieldsAllowed',
        id: undefined,
        buttons: undefined,
        bankPayments: [],
        fieldsPayments: [],
        fieldsSelect: [],


        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },

        start: function () {
            var self = this;

            this.$el.click(function() {
                self.fectchInitial();
            });
            self.buttons.click(function(e) {
                /* C (Crear) */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
            });
        },
        /* Check state*/
        checkState: function(id) {
            var self = this;
            self.id = id;
        },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Método inicial  */
        fectchInitial: function() {
            var self = this;
            self.fectchBankPaymentsType(self.id).then(function(bankPayments) {
                return bankPayments;
            }).then(function(bankPayments) {
                self.bankPayments = bankPayments;
                return self.bankPaymentsFields(self.id);
            }).then(function(fields) {
                self.fieldsPayments = fields;
                return self.joinFieldsPayments();
            }).then(function(fieldsSelect) {
                self.fieldsSelect = fieldsSelect;
                return self.showModalConfig();
            });
        },
        /*  get bank paymnets type */
        fectchBankPaymentsType: function(id) {
            var bankPaymnetsType = new openerp.web.Model('res.bank.payments.type');
            var fields = ['name', 'is_receipt', 'is_payment', 'code', 'default_state','fields_allowed'];
            var domain = [['id', '=', id]];
            return bankPaymnetsType.query(fields).filter(domain).all();
        },
        /* get fields Bank Paymnets */
        bankPaymentsFields: function(id) {
            var self = this;
            var invoiceUpdate = new openerp.web.Model('res.bank.payments.type');
            return invoiceUpdate.call('get_bank_payments_fields',{
                context: new openerp.web.CompoundContext()
            });
        },
        /* Check Campos selecionado */
        joinFieldsPayments: function() {
            var self = this;
            var fieldsAllowed = JSON.parse(self.bankPayments[0].fields_allowed);
            var fieldsSelect = [];
            var fields = [];
            _.each(self.fieldsPayments, function(item){
                var isSelected = _.filter(fieldsAllowed, function(filter){
                    return filter.name === item.name;
                });

                var getTypeField = _.filter(typeFields, function(field){
                    return field.fieldsType.trim() === item.field.type.trim();
                });

                fields.push({
                    'label': !!isSelected.length ?isSelected[0].label :item.field.help.trim(),
                    'labelFields': item.field.help.trim(),
                    'name': item.name.trim(),
                    'selected': !!isSelected.length ?isSelected[0].selected :item.state,
                    'string': {
                        'type': !!getTypeField.length? getTypeField[0].type  : '',
                        'typeField': item.field.type,
                        'model': !!getTypeField.length && getTypeField[0].type === 'model'? item.field.relation : '',
                        'format': !!isSelected.length ? isSelected[0].string.format : !!getTypeField.length ?getTypeField[0].format : '',
                        'required': !!item.field.required ?item.field.required : !!isSelected.length ?isSelected[0].string.required :item.field.required,
                        'requiredFields': item.field.required,
                        'readonly': !!isSelected.length ? isSelected[0].string.readonly : item.field.readonly,
                        'searchType': !!isSelected.length ? isSelected[0].string.searchType: 'none'
                    }
                });
            });
            return fields;
        },
        /* filter */
        filterFieldsRow: function(fieldsSelect,name){
            return _.filter(fieldsSelect, function(item){
                return item.name === name;
            });
        },

        /* bank_payments.ModalConfigFieldsAllowed */
        showModalConfig: function() {
            var self = this;
            var defer = $.Deferred();
            var results = true;

            var modal = QWeb.render('bank_payments.ModalConfigFieldsAllowed',{
                'search': searchType,
                'fieldsSelect': self.fieldsSelect
            });
            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();

            var tableRow = $('.expired-account-modal').find('.table-tbody').find('tr');
            var saveButton = $('.expired-account-modal').find('.add-payments-config-type');

            _.each(tableRow, function(tr) {
                var name = ($(tr).children()[0].textContent).trim();
                var searchType = $($(tr).children()[6]).find('.selected-search-type');
                var selectd = ($($(tr).children()[1]).find('.selected-payments-type-config'))[0].checked;
                var fields = self.filterFieldsRow(self.fieldsSelect,name).shift();
                if (fields)
                    searchType.val(fields.string.searchType);
                    if (fields.string.requiredFields) {
                        ($($(tr).children()[1]).find('.selected-payments-type-config'))[0].checked = true;
                        ($($(tr).children()[1]).find('.selected-payments-type-config')).attr("disabled", true);
                        ($($(tr).children()[4]).find('.select-payments-required')).attr("disabled", true);
                        selectd = true;
                    }
                if (selectd)
                    $(tr).addClass('table-row-selected');

            });

            tableRow.click(function(e){
                var selected = ($($(e.target).closest('tr').children()[1]).find('.selected-payments-type-config'))[0].checked
                if (selected) {
                    $(e.target).closest('tr').addClass('table-row-selected');
                }else{
                    $(e.target).closest('tr').removeClass('table-row-selected');
                }
            });

            saveButton.click(function(e) {
                var fields = []

                _.each(tableRow, function(tr){
                    var selected = ($($(tr).children()[1]).find('.selected-payments-type-config'))[0].checked;
                    if (selected) {
                        var name = ($(tr).children()[0].textContent).trim();
                        var label = $($(tr).children()[2]).find('.input-label-fields').val();
                        var selectedReadOnly = ($($(tr).children()[3]).find('.select-payments-readonly'))[0].checked;
                        var selectedRequired = ($($(tr).children()[4]).find('.select-payments-required'))[0].checked;
                        var format = $($(tr).children()[5]).find('.input-format-fields').val();
                        var searchType = $($(tr).children()[6]).find('.selected-search-type').val();
                        var fieldAllowed = self.filterFieldsRow(self.fieldsSelect,name).shift();

                        fields.push({
                            'label': !!label ?label :fieldAllowed.label,
                            'labelFields':fieldAllowed.labelFields,
                            'name': fieldAllowed.name,
                            'selected': selected,
                            'string':{
                                'type': fieldAllowed.string.type,
                                'typeField': fieldAllowed.string.typeField,
                                'model': fieldAllowed.string.model,
                                'format': format,
                                'required': selectedRequired,
                                'readonly': selectedReadOnly,
                                'searchType': searchType
                            }
                        });
                    }
                });

                self.saveFieldsAllowed(JSON.stringify(fields), self.id).then(function(resultsPaymentsType) {
                    return resultsPaymentsType;
                }).then(function(resultsPaymentsType) {
                    self.reloadPage();
                    $('.expired-account-modal').find('.widget-content.widget-loading-payments').css('display','none');
                    self.removeModal(e);
                    if (!resultsPaymentsType)
                        results = false;
                });

                defer.resolve(results);
            });
            /* Cerrar */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });
            return defer;
        },
        /* Save fieldsAllowed*/
        saveFieldsAllowed: function(fields, id) {
            var paymentType = new openerp.web.Model('res.bank.payments.type');
            return paymentType.call('save_fields_allowed',[{
                'fieldsAllowed': fields,
                'id': id
            }], {
                context: new openerp.web.CompoundContext()
            });
        },
        /* Reload */
        reloadPage: function() {
             openerp.parentInstanceTypeConfig.reload();
        },
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);
                if (this.model !== 'res.bank.payments.type')
                    return;

                openerp.parentInstanceTypeConfig = this;
                if (openerp.widgetInstanceTypeConfig) {
                    openerp.widgetInstanceTypeConfig.checkState(record.id);
                    if (this.$el.find('.fields-allowed-config').length !== 0)
                            return;
                }

                if (this.$el.find('.fields-allowed-config').length !== 0 )
                    return;

                openerp.widgetInstanceTypeConfig = new openerp.BankPaymentsTypeConfig(this);
                var element = this.$el.find('.oe_form').find('.fields-allowed');
                openerp.widgetInstanceTypeConfig.appendTo(element[0]);
                openerp.widgetInstanceTypeConfig.checkState(record.id);

            }
        });
    }

})();
